function []=DescalingJSR_v08(stepJSR)

% function []=DescalingJSR_v08(stepJSR)
%
%      Descaling of P, Pcut, alfa, beta, right, left, N 
%      through value oldAlfa
%
%   See also JSR_V14, SCALINGJSR.

global P Pcut alfa beta right left N oldAlfa LastNormStep;

right=right*oldAlfa;
left=left*oldAlfa;
alfa=alfa*oldAlfa;
beta=beta*oldAlfa;

for j = 1:stepJSR
    field_j=fieldnames(P.(['L' int2str(j)]));
    numProd_j=size(field_j);
    for i = 1:numProd_j(1)
        NameMatrix_ij=char(field_j(i));
        P.(['L' int2str(j)]).(NameMatrix_ij)=P.(['L' int2str(j)]).(NameMatrix_ij)*(oldAlfa^j);
    end
    getField_j=getfield(Pcut,['L' int2str(j)]);
    sizeGetField_j=size(getField_j);
    if sizeGetField_j(1)~=0
        fieldCut_j=fieldnames(Pcut.(['L' int2str(j)]));
        numProdCut_j=size(fieldCut_j);
        for i = 1:numProdCut_j(1)
            NameMatrixCut_ij=char(fieldCut_j(i));
            Pcut.(['L' int2str(j)]).(NameMatrixCut_ij)=Pcut.(['L' int2str(j)]).(NameMatrixCut_ij)*(oldAlfa^j);
        end
    end
end

field_N=fieldnames(N);
sizeField_N=size(field_N);
for j = 1:sizeField_N(1)
    field_j=fieldnames(N.([char(field_N(j))]));
    numL_j=size(field_j);
    for i = 1:numL_j(1)
        field_ij=fieldnames(N.([char(field_N(j))]).(['L' int2str(i)]));
        numProd_ij=size(field_ij);
        for ij = 1:numProd_ij(1)
            NameMatrix_ij=char(field_ij(ij));
            N.([char(field_N(j))]).(['L' int2str(i)]).(NameMatrix_ij)=N.([char(field_N(j))]).(['L' int2str(i)]).(NameMatrix_ij)*oldAlfa;
        end
    end
end