function [SMP,eigSMP]=ScalingJSR(SMP,lengthSMP,eigSMP,stepJSR)

% function []=ScalingJSR(SMP,lengthSMP,eigSMP,stepJSR)
%
%      Scaling of P, Pcut, alfa, beta, right, left 
%      through eigSMP    
%
%   See also JSR_V14, DESCALINGJSR_V08.

global P Pcut alfa beta left right oldAlfa posAlfa

if abs(eigSMP-1)>=10^-15
    if stepJSR~=1
        oldAlfa=oldAlfa*eigSMP;% We store the new scaling value
        for j = 1:stepJSR
            field_j=fieldnames(P.(['L' int2str(j)]));
            numProd_j=size(field_j);
            for i = 1:numProd_j(1)
                NameMatrix_ij=char(field_j(i));
                P.(['L' int2str(j)]).(NameMatrix_ij)=P.(['L' int2str(j)]).(NameMatrix_ij)/(eigSMP^j);
            end
            getField_j=getfield(Pcut,['L' int2str(j)]);
            sizeGetField_j=size(getField_j);
            if sizeGetField_j(1)~=0
                fieldCut_j=fieldnames(Pcut.(['L' int2str(j)]));
                numProdCut_j=size(fieldCut_j);
                for i = 1:numProdCut_j(1)
                    NameMatrixCut_ij=char(fieldCut_j(i));
                    Pcut.(['L' int2str(j)]).(NameMatrixCut_ij)=Pcut.(['L' int2str(j)]).(NameMatrixCut_ij)/(eigSMP^j);
                end
            end
        end
        alfa=alfa/eigSMP;
        beta=beta/eigSMP;
        right=right/eigSMP;
        left=left/eigSMP;
        SMP=SMP/eigSMP^lengthSMP;
        eigSMP=1;
    else % in case stepJSR==1 we have to scale only P
        oldAlfa=oldAlfa*eigSMP;% We store the new scaling value
        for j = 1
            field_j=fieldnames(P.(['L' int2str(j)]));
            numProd_j=size(field_j);
            for i = 1:numProd_j(1)
                NameMatrix_ij=char(field_j(i));
                P.(['L' int2str(j)]).(NameMatrix_ij)=P.(['L' int2str(j)]).(NameMatrix_ij)/(eigSMP^j);
            end            
        end
        SMP=SMP/eigSMP^lengthSMP;
        eigSMP=1;% eigSMP becames 1 due to scaling
    end
end