%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% File used for study_zone
% Requires JSR_v14 def_model_optim3 optim_expo3
%%---------------------------------------------

%model [y pi r]
function out=deter(alpha1,alpha2,p11,p22)
p12=1-p11;
p21=1-p22;
kappa(1)=0.132;
kappa(2)=0.132;
beta(1)=(1+1.11/100)^(-1/4);
beta(2)=(1+3.01/100)^(-1/4);
sigma(1)=1;
sigma(2)=1;
alpha(1)=alpha1;
alpha(2)=alpha2;
gamma(1)=0.15;
gamma(2)=0.30;
rhop(1)=0.53;
rhop(2)=0.84;
for i=1:4 
    switch i
        case 1
            p_=p11;
            sigma_=sigma(1);
            beta_=beta(1);
        case 2
            p_=p12;
            sigma_=sigma(1);
            beta_=beta(1);
        case 3
            p_=p21;
            sigma_=sigma(2);
            beta_=beta(2);
        case 4
            p_=p22;
            sigma_=sigma(2);
            beta_=beta(2);
    end            
    A(:,:,i)=p_*[1 sigma_ 0;0 beta_ 0; 0 0 0];end
for i=1:2 
    B(:,:,i)=[-1 0 -sigma(i);kappa(i) -1 0;(1-rhop(i))*gamma(i) (1-rhop(i))*alpha(i) -1];
    C(:,:,i)=[0 0 0;0 0 0; 0 0 rhop(i)];
end
N=2;
%TO BE FOUND: S1=[0 0 -1.845;0 0 -0.524;0 0 0.559];S2=[0 0 -1.518;0 0 -0.414;0 0 0.514]; (CHO, 2016) = CORRECT!

%% COMPUTATION OF R_{\infty}

% initialisation R.iter_1
R.iter_1=B;

% loop R.iter_{i}
err=1;
i=2;
temp_min=10000;
while err>10^-10
    for st=1:N
        R.(sprintf('iter_%d',i))(:,:,st)=B(:,:,st);%initialisation of R.iter
        for k=1:N
            R.(sprintf('iter_%d',i))(:,:,st)=R.(sprintf('iter_%d',i))(:,:,st)-A(:,:,2*(st-1)+(k-1)+1)*R.(sprintf('iter_%d',i-1))(:,:,k)^(-1)*C(:,:,k);
            %R.(sprintf('iter_%d',i))(:,:,st)=R.(sprintf('iter_%d',i))(:,:,st)-A(:,:,2*(st-1)+(k-1)+1)*R.(sprintf('iter_%d',i-1))(:,:,k)^(-1)*C(:,:,k);
        end
        temp_min=min(temp_min,abs(det(R.(sprintf('iter_%d',i))(:,:,st)))); % index of invertibility
    end
    %R.(sprintf('iter_%d',i))(:,:,2)=B(:,:,2)-(p_21*A(:,:,2)*R.(sprintf('iter_%d',i-1))(:,:,1)^(-1)*C(:,:,1)+p_22*A(:,:,2)*R.(sprintf('iter_%d',i-1))(:,:,2)^(-1)*C(:,:,2));
    if temp_min<10^-15
        warning('non-invertible R');
        err=-1;
    else
        err=0;
        for st=1:N
            err=err+norm(R.(sprintf('iter_%d',i))(:,:,st)-R.(sprintf('iter_%d',i-1))(:,:,st));
        end
    end
    i=i+1;
    if i>1000,
        warning('Convergence of R is too slow');
        err=-2;
    end
end

% definition R.infty
switch err
    case -1
    disp('end of the program');
    R.diagnostic.cvRinfty='Non invertible R_iter ';
    case -2
    disp('end of the program');
    R.diagnostic.cvRinfty='Convergence of R_iter too slow';   
    otherwise
    R.infty=R.(sprintf('iter_%d',i-1));
    R.diagnostic.cvRinfty='Convergence of R_iter valid';
end
for st=1:N
R.JOINMATRIX(:,:,st)=-R.infty(:,:,st)^-1*C(:,:,st);
end
AA(:,:,1)=R.infty(:,:,1)^-1*A(:,:,1)/p11;
AA(:,:,2)=R.infty(:,:,1)^-1*A(:,:,4)/p22;
%AA
[R.JSRad,R.diagnostic.diagnosticJSR,R.diagnostic.sequenceJSR]=JSR_v14(R.JOINMATRIX,5,10^-3,'G');
if R.JSRad(2)>1 & R.JSRad(1)<1
    [R.JSRad,R.diagnostic.diagnosticJSR,R.diagnostic.sequenceJSR]=JSR_v14(R.JOINMATRIX,10,10^-3,'G');
    if R.JSRad(2)>1 & R.JSRad(1)<1
        [R.JSRad,R.diagnostic.diagnosticJSR,R.diagnostic.sequenceJSR]=JSR_v14(R.JOINMATRIX,15,10^-4,'G');
        if R.JSRad(2)>1 & R.JSRad(1)<1
            [R.JSRad,R.diagnostic.diagnosticJSR,R.diagnostic.sequenceJSR]=JSR_v14(R.JOINMATRIX,20,10^-5,'G');
        end
    end
end

if R.JSRad(2)<1
    ti=[1;0;0;1;0;1];qq=5;norm_=1;
    [newti,determin]=def_model_optim3(AA(:,:,1),AA(:,:,2),p11,p22,ti,qq,norm_);
    %if determin>1
        out=optim_expo3(newti,AA(:,:,1),AA(:,:,2),p11,p22,16,norm_);
        %[init,determin]=def_model_optim(AA(:,:,1),AA(:,:,2),p11,p22,ti,qq,norm_);
    %end
else
   out=10;
   disp('Joint spectral radius greater than one')
end

end
