%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% Compute the speed of convergence for multiple choices of norm
%%---------------------------------------------

alpha1=1.4;
alpha2=0.98;
p_11=0.8;
p_22=0.95;
t0=[0;0;0];
qq=16
% FIRST: NORM 1
clear deter time
norm_= 1;
parfor q=1:qq
    tic
    deter(q)=optim_expo(t0,alpha1,alpha2,p_11,p_22,q,norm_);
    time(q)=toc;
end;
STORE_1=[time;deter];
% SECOND: NORM 2
clear deter time
norm_= 2;
parfor q=1:qq
    tic
    deter(q)=optim_expo(t0,alpha1,alpha2,p_11,p_22,q,norm_);
    time(q)=toc;
end;
STORE_2=[time;deter];
% THIRD: NORM FROB
clear deter time
norm_= 'fro';
parfor q=1:qq
    tic
    deter(q)=optim_expo(t0,alpha1,alpha2,p_11,p_22,q,norm_);
    time(q)=toc;
end;
STORE_fro=[time;deter];
% FOURTH: NORM INFINITY
clear deter time
norm_= inf;
parfor q=1:qq
    tic
    deter(q)=optim_expo(t0,alpha1,alpha2,p_11,p_22,q,norm_);
    time(q)=toc;
end;
STORE_inf=[time;deter];

% FIFTH: OPTIMIZATION AND NORM 2
clear deter time
norm_=1;
t0=[0;0;0];
parfor q=1:14
    q
    tic
    [~,deter(q)]=def_model_optim(alpha1,alpha2,p_11,p_22,t0,q,norm_);
    time(q)=toc
end;

STORE_opt2=[time;deter];

% SEVENTH: OPTIMIZATION FOR LOW q THEN ITERATION on q
clear deter time
norm_=1;
t0=[0;0;0];
tic
q=5
[t00,deter(5)]=def_model_optim(alpha1,alpha2,p_11,p_22,t0,q,norm_);
time(5)=toc
timeinit=time(5);
parfor q=6:qq
    q
    tic
    deter(q)=optim_expo(t00,alpha1,alpha2,p_11,p_22,q,norm_);
    time(q)=timeinit+toc;
end;

STORE_MIX=[time;deter];

save store_CONV.mat STORE_MIX STORE_1 STORE_fro STORE_2 STORE_opt2 alpha1 alpha2 p_11 p_22 
QLAPS=[5:16];
scrsz = get(0,'ScreenSize');
 figure1 =figure('Position',[1 1 scrsz(4) scrsz(4)],'PaperSize',[20 20],...
    'Color',[1 1 1])
    axes1 = axes('Parent',figure1,...
    'Position',[0.15 0.2 0.75 0.75],...
    'FontSize',30,...
    'FontName','Times');
    box(axes1,'on');
    hold(axes1,'all');
plot(log10(STORE_fro(1,QLAPS)),STORE_fro(2,QLAPS),'Color',[0.75,0.75,00.75],'LineWidth',3)
hold on;
plot(log10(STORE_1(1,QLAPS)),STORE_1(2,QLAPS),':','Color',[0.75,0.75,00.75],'LineWidth',3)
%plot(log10(STORE_inf(1,QLAPS)),STORE_inf(2,QLAPS),'-x','Color',[0.75,0.75,00.75],'LineWidth',3,'MarkerSize',12)
plot(log10(STORE_2(1,QLAPS)),STORE_2(2,QLAPS),'k','LineWidth',4)
plot(log10(STORE_opt2(1,QLAPS-2)),STORE_opt2(2,QLAPS-2),'k-d','LineWidth',4,'MarkerSize',16)
plot(log10(STORE_MIX(1,QLAPS)),STORE_MIX(2,QLAPS),'k-x','LineWidth',4,'MarkerSize',16)

plot([-4:4],ones(9,1),'k:')
set(gca,'XTick',[-3 -2 -1 0 1 2])
set(gca,'XTickLabel',{1/1000;1/100;1/10;1;10;100})    
xlabel('seconds (log scale)','FontName','Times','FontSize',30)
ylabel('u_k','FontName','Times','FontSize',30)  
set(gca,'Layer','top')    
set(gca, 'Color', 'none');
xlim([-3 3])
ylim([0.9 1.2])
saveas(figure1,'CONV.fig')
export_fig CONV.pdf -painters -transparent


