%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% Name of the graph in the paper: Figure 5
% Graph of determinacy when the other regime is highly persistent but
% deviate modestly from the Taylor Principle
% Need around around 7 hours when parallelized on 4 cores (standard machine in 2015).
%%---------------------------------------------

norm_= 1; % choice of norm
alpha2=[0.96:0.05:4]; % grid for alphas
t0=[1.09;-0.15;0.9]; % initialization for optimization over norms
p_11=0.95;alpha1=0.99; p_22=0.5; % probabilities and policy parameter
qq=5; % lenght of sequence uk in the first 2 steps
deterzone=NaN*ones(size(alpha1,2),size(alpha2,2));
init=NaN*ones(3,size(alpha1,2),size(alpha2,2));

%ALTERNATIVE 1: MAXIMIZATION OVER NORMS for qq=5 (very short but imprecise)
qq=5
i=1;
tic
parfor j=1:size(alpha2,2)
    [init(:,i,j),deterzone(i,j)]=def_model_optim(alpha1(i),alpha2(j),p_11,p_22,t0,qq,norm_);
end
toc

%ALTERNATIVE 2: MAXIMIZATION OVER NORMS for qq=15 using previous directions 'init' (4 hours for 4 cores)
qq=15
i=1;
parfor j=1:size(alpha2,2)
tic    
    [init(:,i,j),deterzone(i,j)]=def_model_optim(alpha1(i),alpha2(j),p_11,p_22,init(:,i,j),qq,norm_);
toc
    j
end

deter_final_bis=(deterzone(:,:,end)+10^-10).*(deterzone(:,:,end)>1-10^-10)
save deter_save_tooweaktoostrong.mat alpha1 alpha2 deterzone


%ALTERNATIVE 3: we push as far as we can u_q using the optimized norm from step 2 (3 hours for 4 cores)
qq=20
tic
i=1
tic
parfor j=1:size(alpha2,2)
    tic
    deterzone2(i,j)=optim_expo(init(:,i,j),alpha1(i),alpha2(j),p_11,p_22,qq,norm_) %second best
    toc
    j
end

deterzone=deterzone2(1,:);
qq_save=qq;
save deter_save_tooweaktoostrong.mat alpha1 alpha2 deterzone qq_save


load deter_save_tooweaktoostrong.mat alpha1 alpha2 deterzone qq_save
% GRAPH OF DETERMINACY UNIVARIATE
scrsz = get(0,'ScreenSize');
 figure1 =figure('Position',[1 1 scrsz(4) scrsz(4)],'PaperSize',[20 20],...
    'Color',[1 1 1])
    axes1 = axes('Parent',figure1,...
    'Position',[0.15 0.2 0.75 0.75],...
    'FontSize',30,...
    'FontName','Times');
    box(axes1,'on');
    hold(axes1,'all');
    fill([1 1.13 1.13 1],[min(deterzone(1,:)) min(deterzone) max(deterzone) max(deterzone)],[1 1 1]*3/4)
    fill([2.737 4 4 2.737],[min(deterzone) min(deterzone) max(deterzone) max(deterzone)],[1 1 1]*3/4)
    hold on;
plot(alpha2,deterzone,'k', 'LineWidth',3);
hold on;
plot(alpha2,ones(size(alpha2,2),1),'k:', 'LineWidth',1);
axis square;
xlabel('\alpha_2','FontName','Times','FontSize',30)
ylabel('\nu','FontName','Times','FontSize',30)
set(gca,'Layer','top')    
set(gca, 'Color', 'none');
xlim([1 4])
ylim([min(deterzone) max(deterzone)])

saveas(figure1,'INTERMRESP.fig')
export_fig INTERMRESP.pdf -painters -transparent