%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% Name of the graph in the paper: Figure 9

% Graph of determinacy wrt probabilities
% Need around around 8 hours when parallelized on 4 cores (standard 2015 machine).
%%---------------------------------------------

norm_=1; % choice of norm
alpha1=1.01;alpha2=6; % grid for alphas
t0=[1.09;-0.15;0.9]; % initialization for optimization over norms
p_11=[0.65:0.05:0.9 0.925:0.025:1];p_22=[0:0.05:0.8]; % probabilities
qq=5; % lenght of sequence uk in the first 2 steps
deterzone=NaN*ones(size(p_11,2),size(p_22,2))
init=NaN*ones(3,size(p_11,2),size(p_22,2))

%ALTERNATIVE 1: MAXIMIZATION OVER NORMS for qq=5 (very short but imprecise)
qq=5
parfor i=1:size(p_11,2)
    i
    tic
    for j=1:17
       [init(:,i,j),deterzone(i,j)]=def_model_optim(alpha1,alpha2,p_11(i),p_22(j),t0,qq,norm_);

    end
    toc
end;

%ALTERNATIVE 2: MAXIMIZATION OVER NORMS for qq=15 using previous directions 'init' (6 hours for 4 cores)
qq=15
parfor i=1:size(p_11,2)
    i
    tic
    for j=1:17
       [init(:,i,j),deterzone(i,j)]=def_model_optim(alpha1,alpha2,p_11(i),p_22(j),init(:,i,j),qq,norm_);
    end
    toc
end;

deter_final=(deterzone(:,:,end)+10^-10).*(deterzone(:,:,end)>1-10^-10)
save deter_save_proba.mat alpha1 alpha2 deterzone deter_final

 
%ALTERNATIVE 3: we push as far as we can u_q using the optimized norm from step 2 (2 hours for 4 cores)
qq=20
tic
parfor i=1:size(p_11,2)
    i
    tic
    for j=1:17
            deterzone(i,j)=optim_expo(init(:,i,j),alpha1,alpha2,p_11(i),p_22(j),qq,norm_) %second best
    end
    toc
end;
deter_final=(deterzone2(:,:,end)+10^-10).*(deterzone2(:,:,end)>1-10^-10)
qq_save=qq;
save deter_save_proba.mat alpha1 alpha2 deterzone  qq_save


load deter_save_proba.mat alpha1 alpha2 deterzone  qq_save
% GRAPH OF DETERMINACY
[GRID_1,GRID_2]=meshgrid(p_11,p_22);
scrsz = get(0,'ScreenSize');
 figure1 =figure('Position',[1 1 scrsz(4) scrsz(4)],'PaperSize',[20 20],...
    'Color',[1 1 1])
    axes1 = axes('Parent',figure1,...
    'Position',[0.15 0.2 0.75 0.75],...
    'FontSize',30,...
    'FontName','Times');
    box(axes1,'on');
    hold(axes1,'all');
h=contourf(GRID_1,GRID_2,deterzone',[1 1],'LineWidth',1);
colormap([[0.3 0.3 0.3];[0.6 0.6 0.6];[1 1 1]])
axis square;
xlabel('p_{11}','FontName','Times','FontSize',30)
ylabel('p_{22}','FontName','Times','FontSize',30)
set(gca,'Layer','top')    
set(gca, 'Color', 'none');
ylim([0.01 1])
xlim([0.01 1])
set(gca,'XTick',[0.01 0.2 0.4 0.6 0.8 1])
set(gca,'XTickLabel',{0;0.2;0.4;0.6;0.8;1})
set(gca,'YTick',[0.01 0.2 0.4 0.6 0.8 1])
set(gca,'YTickLabel',{0;0.2;0.4;0.6;0.8;1})
saveas(gcf,'PROBDET.fig')
export_fig PROBDET.pdf -painters -transparent