%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% Name of the graph in the paper: Figure 4 and 8
% Graphs of output and inflation for the 4 largest contribution of regimes
% trajectories to u_16
% Requires sp2_fra and sp5_fra
%%---------------------------------------------

%% PARAMETERS

%PROBABILITIES: <FWZ-DL: 0.8 0.95 // autre essai:0.95 0.99>
p_11=0.95;p_12=1-p_11;p_22=0.5;p_21=1-p_22;Proba=[p_11 1-p_11;1-p_22 p_22];
%OTHER PARAMETERS
sigma=1;beta=0.99;kappa=0.17;%Structural parameters
%KEY PARAMETRES 
alpha_1a=1.01;
alpha_2a=6;
[dl,sp_fra]=sp2_fra(alpha_1a,alpha_2a,p_11,p_22,sigma,beta,kappa)
[dl,sp_fra,STRUCT]=sp5_fra(alpha_1a,alpha_2a,p_11,p_22,sigma,beta,kappa)

for i=1:size(STRUCT.q16.totsig,3)
NORMa(i)=norm(STRUCT.q16.totsig(:,:,i));
end;

[SORT_a,IXa]=sort(NORMa);

%WEIGHTS TEST
S=dec2bin(0:1:2^16-1,16);
for i=1:2^16
    WEIGHTS_NORMa=eval(['p_' num2str(str2num(S(end,end))+1) num2str(str2num(S(end,1))+1)])*NORMa;
end
    
[WEIGHTS_SORT_a,WEIGHTS_IXa]=sort(WEIGHTS_NORMa);
%END OF TEST
disp([num2str(SORT_a(end-9)) '   ' num2str(dec2bin(IXa(end-9)-1,16))])
disp([num2str(SORT_a(end-8)) '   ' num2str(dec2bin(IXa(end-8)-1,16))])
disp([num2str(SORT_a(end-7)) '   ' num2str(dec2bin(IXa(end-7)-1,16))])
disp([num2str(SORT_a(end-6)) '   ' num2str(dec2bin(IXa(end-6)-1,16))])
disp([num2str(SORT_a(end-5)) '   ' num2str(dec2bin(IXa(end-5)-1,16))])
disp([num2str(SORT_a(end-4)) '   ' num2str(dec2bin(IXa(end-4)-1,16))])
disp([num2str(SORT_a(end-3)) '   ' num2str(dec2bin(IXa(end-3)-1,16))])
disp([num2str(SORT_a(end-2)) '   ' num2str(dec2bin(IXa(end-2)-1,16))])
disp([num2str(SORT_a(end-1)) '   ' num2str(dec2bin(IXa(end-1)-1,16))])
disp([num2str(SORT_a(end)) '   ' num2str(dec2bin(IXa(end)-1,16))])

REGIME=dec2bin(0,16)';
for i=1:size(STRUCT.q16.totsig,3)
    REGIME(1:16,i)=(dec2bin(IXa(i)-1,16))';
end
for i=1:16
for j=1:size(STRUCT.q16.totsig,3)
   if REGIME(i,j)=='1';
       REGIME(i,j)='2';
   else
       REGIME(i,j)='1';
   end
end
end

%GRAPH MAIN CONTRIBUTIONS
scrsz = get(0,'ScreenSize');
figure1 =figure('Position',[1 1 scrsz(4) scrsz(4)],'PaperSize',[20 20],...
    'Color',[1 1 1])
    axes1 = axes('Parent',figure1,...
    'Position',[0.15 0.5 0.75 0.45],...
    'FontSize',30,...
    'FontName','Times');
    box(axes1,'on');
    hold(axes1,'all');
    plot(SORT_a([size(STRUCT.q16.totsig,3)-9:1:size(STRUCT.q16.totsig,3)]),'k','LineWidth',3)
    set(gca,'XTick',[1:10])

    ylabel('Contribution to u_{16}','FontSize',30,'FontName','Times')
XTickLabel = get(gca,'XTickLabel');

hxLabel = get(gca,'XLabel');
set(hxLabel,'Units','data');
xLabelPosition = get(hxLabel,'Position');
y = xLabelPosition(2);
XTick = get(gca,'XTick');
y=repmat(y,length(XTick),1);
fs = get(gca,'fontsize');

hText.(sprintf('Am%d',1)) = text(-1*ones(1,16),y(1)*ones(1,16),  ('Future regimes    '));
set(hText.(sprintf('Am%d',1)),'Rotation',90,'HorizontalAlignment','right','FontSize',30);

hText.(sprintf('A%d',0)) = text(0*ones(1,16),y(1)*ones(1,16),  ('s_t .................... s_{t+16}'));
set(hText.(sprintf('A%d',0)),'Rotation',90,'HorizontalAlignment','right','FontSize',30);
for i=1:size(XTick,2)
hText.(sprintf('A%d',i)) = text(XTick(i)*ones(1,16),y(1)*ones(1,16),  (REGIME(1:16,size(STRUCT.q16.totsig,3)+i-10))');
set(hText.(sprintf('A%d',i)),'Rotation',90,'HorizontalAlignment','right','FontSize',30);
end
set(gca,'XTickLabel',[]);

set(gca,'Layer','top')    
set(gca, 'Color', 'none');

%saveas(gcf,'graph_largest_contributions.fig') figure 2 du papier

%GRAPH EXPECTATIONS EFFECT FOR MAIN CONTRIBUTORS


A_1a=[1 sigma;0 beta];
A_2a=[1 sigma;0 beta];
B_1a=[1 sigma*alpha_1a;-kappa 1];
B_2a=[1 sigma*alpha_2a;-kappa 1];
At_1a=B_1a^(-1)*A_1a;
At_2a=B_2a^(-1)*A_2a;

for j=2^16-9:2^16
    TRAJ_a1(:,17,j)=[1;0];
    TRAJ_a2(:,17,j)=[0;1];
    for i=1:16
        if REGIME(17-i,j)=='1'
        TRAJ_a1(:,17-i,j)=At_1a*TRAJ_a1(:,17-i+1,j);
        TRAJ_a2(:,17-i,j)=At_1a*TRAJ_a2(:,17-i+1,j);
        else
        TRAJ_a1(:,17-i,j)=At_2a*TRAJ_a1(:,17-i+1,j);
        TRAJ_a2(:,17-i,j)=At_2a*TRAJ_a2(:,17-i+1,j);
        end
    end
end

scrsz = get(0,'ScreenSize');
 figure1 =figure('Position',[1 1 scrsz(4) scrsz(4)],'PaperSize',[20 20],...
    'Color',[1 1 1])
    axes1 = axes('Parent',figure1,...
    'Position',[0.15 0.5 0.75 0.45],...
    'FontSize',30,...
    'FontName','Times');
    box(axes1,'on');
    hold(axes1,'all');
    subplot(2,2,1)
plot(TRAJ_a1(1,:,end)','r-x','LineWidth',3)
hold on
plot(TRAJ_a1(1,:,end-1)','k','LineWidth',3)
plot(TRAJ_a1(1,:,end-2)','b:d','LineWidth',2)
plot(TRAJ_a1(1,:,end-3)','g:s','LineWidth',2)
set(gca,'XTick',[2 4 6 8 10 12 14 16],'FontSize',30,'FontName','Times')
xlim([1 17])
ylim([-2.5 1])
ylabel('Output-gap','FontSize',30,'FontName','Times')
title('Output-gap expectation','FontSize',30,'FontName','Times')
subplot(2,2,3)
plot(TRAJ_a1(2,:,end)','r-x','LineWidth',3)
hold on
plot(TRAJ_a1(2,:,end-1)','k','LineWidth',3)
plot(TRAJ_a1(2,:,end-2)','b:d','LineWidth',2)
plot(TRAJ_a1(2,:,end-3)','g:s','LineWidth',2)
set(gca,'XTick',[2 4 6 8 10 12 14 16],'FontSize',30,'FontName','Times')
xlim([1 17])
ylim([-0.25 1])
ylabel('Inflation','FontSize',30,'FontName','Times')    
    
    subplot(2,2,2)
plot(TRAJ_a2(1,:,end)','r-x','LineWidth',3)
hold on
plot(TRAJ_a2(1,:,end-1)','k','LineWidth',3)
plot(TRAJ_a2(1,:,end-2)','b:d','LineWidth',2)
plot(TRAJ_a2(1,:,end-3)','g:s','LineWidth',2)
set(gca,'XTick',[2 4 6 8 10 12 14 16],'FontSize',30,'FontName','Times')
xlim([1 17])
ylim([-2.5 1])
title('Inflation expectation','FontSize',30,'FontName','Times')

subplot(2,2,4)
plot(TRAJ_a2(2,:,end)','r-x','LineWidth',3)
hold on
plot(TRAJ_a2(2,:,end-1)','k','LineWidth',3)
plot(TRAJ_a2(2,:,end-2)','b:d','LineWidth',2)
plot(TRAJ_a2(2,:,end-3)','g:s','LineWidth',2)
set(gca,'XTick',[2 4 6 8 10 12 14 16],'FontSize',30,'FontName','Times')
xlim([1 17])
ylim([-0.25 1])

%saveas(gcf,'expected_impact_4largest.fig') figure 3 du papier


