%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% File required for determinacy
% Compute the norm u_q and many other important elements in a structure
% STRUCT
%%---------------------------------------------

function [dl,rho,STRUCT]= sp5_fra(alpha_1,alpha_2,p_11,p_22,sigma,beta,kappa,option)
A_1=[1 sigma;0 beta];
A_2=[1 sigma;0 beta];
B_1=[1 sigma*alpha_1;-kappa 1];
B_2=[1 sigma*alpha_2;-kappa 1];
At_1=B_1^(-1)*A_1;
At_2=B_2^(-1)*A_2;
At(1:2,1:2)=At_1;At(3:4,3:4)=At_2;

Proba=[[p_11 (1-p_11)];[(1-p_22) p_22]];
fat1 = At(2*1-1:2*1,2*1-1:2*1)
fat2 = At(2*2-1:2*2,2*2-1:2*2);

P=[p_11*At_1 (1-p_11)*At_1; (1-p_22)*At_2 p_22*At_2];
dl=max(abs(eig(P)));
if nargin==8 & option=='dl'
    rho=Inf;
else
    
    for q=1:5
        q
        STRUCT.(sprintf('q%d',q)).totsig=zeros(2,2,2^q);
        for i=1:2
            for j=1:2
                STRUCT.(sprintf('q%d',q)).(sprintf('A%d%d',i,j))=[];
            end
        end
        for ind=1:2^q
            Mind=dec2bin(ind-1,q);
            STRUCT.(sprintf('q%d',q)).(sprintf('A%d%d',bin2dec(Mind(1))+1,bin2dec(Mind(end))+1))=[STRUCT.(sprintf('q%d',q)).(sprintf('A%d%d',bin2dec(Mind(1))+1,bin2dec(Mind(end))+1)) ind];
            sig=eye(2,2);
            for k=1:q-1
                if bin2dec(Mind(k)) == 0
                    sig=sig*fat1*Proba( bin2dec(Mind(k))+1, bin2dec(Mind(k+1))+1);
                else
                    sig=sig*fat2*Proba( bin2dec(Mind(k))+1, bin2dec(Mind(k+1))+1);
                end
            end
            if bin2dec(Mind(q)) == 0
                sig=sig*fat1;
            else
                sig=sig*fat2;
            end
            STRUCT.(sprintf('q%d',q)).totsig(:,:,ind)=sig;
        end
        
        s=zeros(2,2);
        for i=1:2
            for j=1:2
                for ind=STRUCT.(sprintf('q%d',q)).(sprintf('A%d%d',i,j))
                    s(i,j)=s(i,j)+norm(STRUCT.(sprintf('q%d',q)).totsig(:,:,ind),1);
                    
                end,
            end
        end
        STRUCT.(sprintf('q%d',q)).rho=(max(eig(s)))^(1/q);
        rho(q)=(max(eig(s)))^(1/q);
        STRUCT.(sprintf('q%d',q)).s=s;
    end
    
  %% DEUXIEME BOUCLE AVEC COUPURES  
  precision=10^-7;
    for q=6:16
        q
        STRUCT.(sprintf('q%d',q)).totsig=zeros(2,2,2^q);
        for i=1:2
            for j=1:2
                STRUCT.(sprintf('q%d',q)).(sprintf('A%d%d',i,j))=[];
            end
        end
        for ind=1:2^q
            Mind=dec2bin(ind-1,q);
            STRUCT.(sprintf('q%d',q)).(sprintf('A%d%d',bin2dec(Mind(1))+1,bin2dec(Mind(end))+1))=[STRUCT.(sprintf('q%d',q)).(sprintf('A%d%d',bin2dec(Mind(1))+1,bin2dec(Mind(end))+1)) ind];
            sig=eye(2,2);
            for k=1:q-1
                if bin2dec(Mind(k)) == 0
                    sig=sig*fat1*Proba( bin2dec(Mind(k))+1, bin2dec(Mind(k+1))+1);
                else
                    sig=sig*fat2*Proba( bin2dec(Mind(k))+1, bin2dec(Mind(k+1))+1);
                end
            end
            if bin2dec(Mind(q)) == 0
                sig=sig*fat1;
            else
                sig=sig*fat2;
            end
            STRUCT.(sprintf('q%d',q)).totsig(:,:,ind)=sig;
        end
        
        s=zeros(2,2);
        s_cut=zeros(2,2);
        cut=0;
        for i=1:2
            for j=1:2
                for ind=STRUCT.(sprintf('q%d',q)).(sprintf('A%d%d',i,j))
                    s(i,j)=s(i,j)+norm(STRUCT.(sprintf('q%d',q)).totsig(:,:,ind),1);
                    if norm(STRUCT.(sprintf('q%d',q)).totsig(:,:,ind),1)>2^(-q)*precision
                        s_cut(i,j)=s_cut(i,j)+norm(STRUCT.(sprintf('q%d',q)).totsig(:,:,ind),1);
                    else
                        cut=cut+1;
                    end
                end,
            end
        end
        STRUCT.(sprintf('q%d',q)).rho=(max(eig(s)))^(1/q);
        STRUCT.(sprintf('q%d',q)).rho_cut=(max(eig(s_cut)))^(1/q);
        STRUCT.(sprintf('q%d',q)).cut=cut;
        
        rho(q)=(max(eig(s)))^(1/q);
        STRUCT.(sprintf('q%d',q)).s=s;
    end
end
end
%for i=1:40 for j=1:40 [dl4(i,j),bm4(i,j)]=deter_revu(0.8+0.025*i,0.8+0.025*j);end, end
%figure;contour([0.825:0.025:1.8],[0.825:0.025:1.8],dl4,1,'r');hold on;contour([0.825:0.025:1.8],[0.825:0.025:1.8],bm4,1,'k');
% for i=1:40 for j=1:40 if dl(i,j)<1 dummy_dl(i,j)=1; else dummy_dl(i,j)=0;end, if spm(i,j)<1 dummy_sp(i,j)=1; else dummy_sp(i,j)=0;end,end,end
% figure;contour([0.75:0.05:2.7],[0.75:0.05:2.7],dummy_dl,1,'r');hold on;contour([0.75:0.05:2.7],[0.75:0.05:2.7],dummy_sp,1,'k');