%%---------------------------------------------
%-----------Barthlemy & Marx (2018)-----------
%----------------------------------------------
% Name of the graph in the paper: Figure 6
% Graph of determinacy vis--vis probabilities when parameters are
% calibrated as in Lubik and Schorfheide (2004)
% Needed files: deter
%%---------------------------------------------


%-------------------------------------------------------------------------%
% Lubik Schorfheide (2004) no expectations of regime switching = p11=p22=1;
%-------------------------------------------------------------------------%

alpha1=0.89;
alpha2=2.19;
p11=1;
p22=1;
deter(alpha1,alpha2,p11,p22)
%Standard result: Taylor principle not verified in regime 1 => indeterm
%-------------------------------------------------------------------------%

%-------------------------------------------------------------------------%
% Lubik Schorfheide (2004) what if economic agents expect regime switching?
%-------------------------------------------------------------------------%
alpha1=0.89;
alpha2=2.19;
p11=0.9;
p22=0.95;
tic
deter(alpha1,alpha2,p11,p22)
toc
%Confirm DL's intuition if econ agents expect Taylor Principle => determ.
%-------------------------------------------------------------------------%

%-------------------------------------------------------------------------%
% Lubik Schorfheide (2004) what is the minimum prob leading to determ?
%-------------------------------------------------------------------------%
alpha1=0.89;
alpha2=2.19;
p11=[0.8:0.01:1];
p22=[0.8:0.1:1];
for i=1:size(p11,2) 
    i
    for j=1:size(p22,2) 
        deterzoneproba(i,j)=deter(alpha1,alpha2,p11(i),p22(j))
    end;
end;
[P11,P22] = meshgrid(p11,p22);
scrsz = get(0,'ScreenSize');
 figure1 =figure('Position',[1 1 scrsz(4) scrsz(4)],'PaperSize',[20 20],...
    'Color',[1 1 1])
    axes1 = axes('Parent',figure1,...
    'Position',[0.15 0.2 0.75 0.75],...
    'FontSize',30,...
    'FontName','Times');
    box(axes1,'on');
    hold(axes1,'all');
    hold on;
contourf(P11,P22,deterzoneproba',[1 1])
colormap(gray)
axis square;
xlabel('p_{11}','FontName','Times','FontSize',30)
ylabel('p_{22}','FontName','Times','FontSize',30)
set(gca,'Layer','top')    
set(gca, 'Color', 'none');
saveas(figure1,'PROBA_LS.fig')
export_fig PROBA_LS.pdf -painters -transparent

%determ emerges only if agents expect a prob to switch to reg 2 higher to?
%-------------------------------------------------------------------------%

%-------------------------------------------------------------------------%
% Should we fear a "too strong response to inflation?"
%-------------------------------------------------------------------------%
alpha1=[0.8:0.05:1.1 1.25:0.25:3.5];alpha2=[0.8:0.05:1.1 1.25:0.25:3.5];
p11=0.9;
p22=0.95;
for i=1:size(alpha1,2) for j=1:size(alpha2,2) 
        disp([i j])
        deterzonealpha(i,j)=deter(alpha1(i),alpha2(j),p11,p22);
    end;
end;
deter(alpha1,alpha2,p11,p22)
%Confirm DL's intuition if econ agents expect Taylor Principle => determ.
%-------------------------------------------------------------------------%
